/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package consoleengcalculator;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import javax.swing.JPanel;

/**
 *
 * @author simone
 */
public class GradientJPanel extends JPanel {
    private boolean showGradient = false;

    public void setShowGradient(boolean showGradient) {
        this.showGradient = showGradient;
    }

    @Override
    public void paint(Graphics g) {
        super.paint(g);

        if (showGradient) {
            final Dimension size = getSize();
            final float dColor = CartesianPlane.MAXHUE/size.width;
            float color = -dColor;
            for (int i=0;i<size.width;++i) {
                g.setColor(Color.getHSBColor(color+=dColor, 1f, 1f));
                g.drawLine(i, 0, i, size.height);
            }
        }
    }

}
