/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.cumulative;

import engcalculator.function.infix.engineering.SumSquared;
import engcalculator.data.Interval;
import engcalculator.data.IntervalList;

/**
 *
 * @author simone
 */
public class SumSquaredUp extends InfixToPrefix {
    private final static SumSquared SUM_SQUARED = new SumSquared();
    private final static String[] EXAMPLE = {"1, 2, 3"};
    private final static String[] RESULT = {"3.742"};    

    public SumSquaredUp() {
        super (SUM_SQUARED.getSymbol(), "sum the square of the intervals in the list and then extracts the square root of the result: sqrt(sqr(a)+sqr(b)+sqr(c)...", EXAMPLE, RESULT);
    }

    @Override
    protected Interval __compute(IntervalList input) throws Exception {
        return SUM_SQUARED._compute(input.subList(0, 1), input.subList(1, 2)).getFirst();
    }
}