/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.engineering;

import engcalculator.data.Interval;
import engcalculator.function.prefix.cumulative.SumUp;
import engcalculator.function.infix.arithmetic.Div;
import engcalculator.data.IntervalList;
import engcalculator.function.CalculusException;
import engcalculator.function.infix.arithmetic.Sum;
import engcalculator.function.prefix.PrefixFunction;
import engcalculator.function.prefix.interval.Invert;

/**
 *
 * @author simone
 */
public class Partition extends PrefixFunction {
    private final static SumUp SUM_UP = new SumUp();
    private final static Div DIV = new Div();
    private final static Sum SUM = new Sum();
    private final static Invert INVERT = new Invert();
    private final static Interval ONE = new Interval (1);

    private final static String[] EXAMPLE = {"1, 2, 3, 4"};
    private final static String[] RESULT = {"0.1"};

    public Partition() {
        super ("partition", (byte) -1, false, true, "partition computes the partition ratio among the first given value and the sum of all given values: partition (a, b, c, ...) = 1/(1+(b+c+...)/a).", EXAMPLE, RESULT);
    }

    @Override
    public IntervalList _compute(IntervalList input) throws Exception {
        if (input.size() < 2) throw new CalculusException ("At least an interval is required");

        return new IntervalList (INVERT._computeIntervals(SUM._computeIntervals(ONE, DIV._computeIntervals(SUM_UP._compute(input.subList(1, input.size())).getFirst(), input.getFirst()))));
    }

}
