/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.interval;

import engcalculator.data.Interval;
import engcalculator.function.prefix.SingleInputSingleOutputPrefixFunction;


/**
 *
 * @author simone
 */
public class Proper extends SingleInputSingleOutputPrefixFunction {
    private final static String[] EXAMPLE = {"-10_10", "10_-5", "10_-10"};
    private final static String[] RESULT = {"-10_10", "-5_10", "-10_10"};

    public Proper() {
        super("proper", true, true, "proper returns proper part (projection) of the directed interval A, which is A if A is proper and dual(A) is A is not proper.", EXAMPLE , RESULT);
    }
    
    @Override
    public Interval _computeIntervals (Interval a) throws Exception {
        if (a.isProper()) return a;
        return new Interval (a.getRight(), a.getLeft());
    }
}
