/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.infix.compare;


import engcalculator.data.Interval;
import engcalculator.function.infix.DualInputSingleOutputInfixFunction;

/**
 *
 * @author simone
 */
public abstract class ComparisonInfixFunction extends DualInputSingleOutputInfixFunction {
    private final static Interval TRUE =  new Interval (1);
    private final static Interval FALSE =  new Interval (0);

    public ComparisonInfixFunction(String name, String help, String[] examplesleft, String[] examplesright, String[] results) {
        super(name, true, true, help, examplesleft, examplesright, results);
    }

    @Override
    public final Interval _computeIntervals (Interval leftSide, Interval rightSide) throws Exception {
        if (compare (leftSide, rightSide)) return TRUE;
        else return FALSE;
    }

    public abstract boolean compare (Interval a, Interval b) throws Exception;

}
