/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.infix.set;


import engcalculator.data.Interval;
import engcalculator.function.infix.DualInputSingleOutputInfixFunction;

/**
 *
 * @author simone
 */
public class Union extends DualInputSingleOutputInfixFunction {
private final static String[] EXAMPLE_LEFT = {"6_7","5_7", "1_2", "3_4"};
    private final static String[] EXAMPLE_RIGHT = {"4_5","4_6", "2_4", "-3_-2"};
    private final static String[] RESULT = {"4_7","4_7","1_4","-3_4"};

    public Union() {
        super("|", true, true, "| returns the unions between two intervals. Since the system works only on single interval the joining may contain also points not available in the two intervals if they are disjunct.", EXAMPLE_LEFT, EXAMPLE_RIGHT, RESULT);
    }

    @Override
    public Interval  _computeIntervals (Interval ls, Interval rs) throws Exception {
        return new Interval (Math.min(ls.getLeft(), rs.getLeft()), Math.max(ls.getRight(), rs.getRight()));
    }

}
