/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix;

import engcalculator.data.Interval;
import engcalculator.data.IntervalList;

/**
 *
 * @author simone
 */
public abstract class SingleInputSingleOutputPrefixFunction extends PrefixFunction {

    public SingleInputSingleOutputPrefixFunction(String name, boolean expandsToLists, boolean constant, String help, String[] examples, String[] results) {
        super(name, (byte) 1, expandsToLists, constant, help, examples, results);
    }

    @Override
    public final IntervalList _compute(IntervalList input) throws Exception {
        return new IntervalList (_computeIntervals(input.getFirst()));
    }

    public abstract Interval _computeIntervals (Interval input) throws Exception;

}
